NAV
shell

General

Welcome

The Relay API provides REST endpoints to manage all communication aspects of your communities:

Endpoint

Production: https://relay-api.d6.co.za

Versioning

The URL will contain a version number with ‘v’ prefix (E.g v1, v2) at the beginning of the query. E.g: https://relay-api.d6.co.za/api/business/v1/communities

Authentication


## Get Access Token (Client Credentials)
curl -X "POST" "https://id.zipalong.tech/connect/token" \
     -H 'Content-Type: application/x-www-form-urlencoded; charset=utf-8' \
     --data-urlencode "grant_type=client_credentials" \
     --data-urlencode "client_id={CLIENT_ID}" \
     --data-urlencode "client_secret={CLIENT_SECRET}" \
     --data-urlencode "scope=relay.business.full_access relay_uploads.upload"

Example Response:

{
  "access_token": "REDACTED", # The access token
  "expires_in": 604800,
  "token_type": "Bearer",
  "scope": "relay.business.full_access relay_uploads.upload"
}

Relay uses the d6 Identity Service (OAuth) for authentication and access to your server resources. All API requests require an access token which can be retrived using the Client Credentials grant type:

All API requests must be made over HTTPS. Requests made over plain HTTP will fail and may risk exposing your key.

Status Codes

Relay uses status codes that adhere to the HTTP/1.1 standard (RFC 7231):

Code Name Description
200 OK The request has succeeded.
201 Created Resource has been created.
202 Accepted The request has been accepted for processing, but the processing has not been completed.
204 No Content Resource has been deleted.
400 Bad Request The request was invalid. E.g. No access token provided, an invalid UUID, or the request could not be completed.
401 Unauthorized The access token is invalid or has expired.
403 Forbidden The server understood the request, but is refusing it or the access is not allowed. E.g. The access token does not have the required scope.
404 Not Found The resource was not found.
422 Unprocessable Entity The server understood the request, but was unable to process the contained instructions. Normally due to missing or malformed parameters (validation errors).
429 Too Many Requests Rate limits have been reached, please slow down your requests.
500 Internal Server Error Internal server error which has been logged and being attended to. Please try again later.
503 Service Unavailable API is down for maintenance. Please try again later.

Rate Limiting

Please be aware that should you exceed these limits you will receive a 429 (Too Many Requests) error:

Every request will return X-RateLimit-Limit and X-RateLimit-Remaining in the headers to manage your throttling if necessary.

Date and Time

The date & time format used by the API is ISO 8601 UTC compliant:

Errors & Bad Requests

{
  "message": "The error message goes here."
}

Errors or bad requests caught by the API will always return a JSON object with a message key. The value will always be a string.

Paginated Lists

Example:

{
  "data": [
    {
      "id": 1,
      "name": "Object 1",
    },
    {
      "id": 2,
      "name": "Object 2",
    }
  ],
  "pagination": {
    "total": 4,
    "count": 2,
    "per_page": 2,
    "current_page": 1,
    "total_pages": 2,
    "links": {
      "next": "http:\/\/relay-api.d6.co.za\/api\/business\/v1\/communities?page=2"
    }
  }
}

Many different requests in the Relay API provide the ability to paginate results. All paginated results follow the same response structure:

Expanding Relationships

curl "https://relay-api.d6.co.za/api/business/v1/channels/{id}?expand=community" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json"

Example Response:


{
  "id": 1,
  "community_id": 1,
  "name": "Channel Name",
  "created_at": "2020-09-22T08:29:00Z",
  "updated_at": "2020-09-22T08:29:00Z",

  "community": {
    "id": 1,
    "name": "Community Name",
    "created_at": "2020-09-22T08:29:00Z",
    "updated_at": "2020-09-22T08:29:00Z"
  }
}

Certain resources may reference other resources via their unique id. E.g: A channel belongs to a community.

Instead of making 2 requests to fetch a channel and then the community it belongs to, we can simply request the channel with an expand parameter/argument of 'community'. The response will then include the community as well.

All resources that have expandable relationships are documented in the requests found below.

Dedicated File Upload Endpoint

We provide an endpoint for you to upload, download and view files. This will avoid you having to to construct multipart form data requests. Instead, file id parameters can be provided in your JSON.

curl  -X "POST" "https://relay-uploads.d6.co.za/api/upload/v1/files" \
      -H "Authorization: Bearer {ACCESS_TOKEN}" \
      -H "Accept: application/json" \
      -H 'Content-Type: multipart/form-data; charset=utf-8; boundary=__X_PAW_BOUNDARY__' \
      -F "file=" \
      -F "metadata=\"{\\\"test\\\":\\\"data\\\"}\""

Example Response:

{
  "id": "95605ad2-d1f8-46ce-841c-ba42884903e8",
  "expires_at": "2022-01-24T09:12:11Z"
}

Request

POST https://relay-uploads.d6.co.za/api/upload/v1/files

Arguments (JSON)

Parameter Type Description
file
Optional
file The file you would like to upload. Both the file and url parameters cannot be populated at the same time.
url
Optional
string The url to the file you would like to upload.
metadata
Optional
string The file's metadata.
expires_at
Optional
date The file expiry date.
sandbox
Optional
boolean Whether to fake uploading the file.

Returns

An object with an id and expires_at attributes with status code 200 (OK).

Communities

Communities represent businesses, clubs or schools. All data is segregated by community including notices & members.

Create a Community

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: multipart/form-data; charset=utf-8; boundary=__X_D6_BOUNDARY__' \
     -F "name=Community Name" \
     -F "type=school" \
     -F "email=contact@example.org" \
     -F "website=https://www.example.org" \
     -F "address=14 John Doe Street, Lynnwood, Pretoria" \
     -F "tier_id={TIER_ID}" \
     -F "image=" \
     -F "cover_image=" \
     -F "default_country_calling_code=27"

Example Response:

{
    "id": "92f6ff6e-dbee-4408-a736-6a8d43ccaf3f",
    "status": "active",
    "status_at": "2021-12-23T20:53:58Z", // When status was last changed
    "type": "school",
    "source": "manual",
    "invite_only": false,
    "locale": "en",
    "name": "Community Name",
    "short_name": null,
    "email": "contact@example.org",
    "phone_number": null,
    "website": "https:\/\/www.example.org",
    "address": "14 John Doe Street, Lynnwood, Pretoria",
    "image": "https:\/\/cdnrly.d6.co.za\/cm\/92f6ff6e-dbee-4408-a736-6a8d43ccaf3f\/60509b9f16f02\/20210316_b8a449891590bde01b7c79b7913269fe.jpg",
    "image_blurhash": "USMaR]?bj[M{~q-;j[j[_3ofWBM{ofWBofof",
    "image_width": 600,
    "image_height": 600,
    "cover_image": "https:\/\/cdnrly.d6.co.za\/cm\/92f6ff6e-dbee-4408-a736-6a8d43ccaf3f\/60657e3c9b039\/20210401_6347b9d342342a91dffe01f4281ba765.jpg",
    "cover_image_blurhash": "LeODIK-Vbbo}~qj[aej]57XSi_a0",
    "cover_image_width": 1067,
    "cover_image_height": 600,
    "email_cover_image": "https:\/\/cdnrly-staging.d6.co.za\/cm\/952f0b30-1dab-4ec1-a955-cd6c183fe09d\/62737b10ed1e1\/20220505_a64b18138a2a10fe90a5c4934f3a6aef.jpg",
    "d6_unique_zoho_reference": null,
    "account_contact_name": "John Doe",
    "account_contact_phone_number": null,
    "account_contact_email": null,
    "account_contact_notes": null,
    "app_accessible": true,
    "portal_accessible": true,
    "internal_stats_collection_enabled": false,
    "timezone": "UTC",
    "app_download_url": "https:\/\/www.d6.co.za",
    "ads_legacy_mobile_keyword": null,
    "ads_legacy_desktop_keyword": null,
    "default_country_calling_code": 27,
    "default_portal_notice_distribution_relationship": "default",
    "default_app_notice_distribution_relationship": "default",
    "default_portal_notice_platform_distribution_grouping": "app_email_sms",
    "default_app_notice_platform_distribution_grouping": "app_email_sms",
    "inactivity_reminder_emails_enabled": true,
    "default_currency_iso_4217": null,
    "portal_primarily_used": false,
    "allow_portal_locked_person_channel_updates": false,
    "legacy_d6_connect_id": null,
    "close_at": null,
    "created_at": "2021-03-16T11:50:55Z",
    "updated_at": "2021-04-01T08:03:08Z",
    "is_internal_community": false,
    "internal_community_description": null,
    "is_review_community": false,
    "hidden_notice_components": [],
    "new_comms_experience": false
}

Creates a new community.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities

Arguments (JSON)

Parameter Type Description
name
Required
string The name of the community. Max length of 255 characters.
type
Required
string Available types: 'school', 'club', 'business', 'other', 'unknown'.
tier_id
Required
string The identifier (UUID) of the tier to create the community's plan from. These IDs will be provided to you.
short_name
Optional
string A short name for the community. Max length of 10 characters.
status
Optional
string The status of the community. Available types: 'active', 'closed'. Defaults to 'active'.
email
Optional
string The email address of the community. Must be a valid email address. Max length of 255 characters.
phone_number
Optional
string The phone number of the community. Max length of 255 characters.
website
Optional
string The website of the community. Must be a valid URL. Max length of 255 characters.
address
Optional
string The physical address of the community. Max length of 255 characters.
image
Optional
file The logo of the community. Used in email headers and within the apps.

Supported Formats:
jpg, png, gif, heic, heif

Max file size of 10MB.
cover_image
Optional
file The cover image of the community. Used in email headers and within the apps.

Supported Formats:
jpg, png, gif, heic, heif

Max file size of 10MB.
apps
Optional
array Array of objects of apps this community should be attached to, each with a required id (App ID, provided to you) and an optional visible boolean.
app_ids
Optional
array Array of App IDs this community should be attached to. These IDs will be provided to you. Kept for backwards compatibility; prefer apps.
region_ids
Optional
array Array of Region IDs this community should be attached to. These IDs will be provided to you.
locale
Optional
string The locale code (E.g en) of the community. Gets used for deciding the language to use throughout the service such as emails. Defaults to 'en'.
d6_unique_zoho_reference
Optional
string Internal usage. Must be unique across communities. Max length of 255 characters.
account_contact_name
Optional
string The name of the account contact. Max length of 255 characters.
account_contact_phone_number
Optional
string The phone number for this account's contact. Must be a valid mobile number.
account_contact_email
Optional
string The email address for this account's contact. Must be a valid email address. Max length of 255 characters.
account_contact_notes
Optional
string Additional notes for this account. This field can be used for malformed account_contact_phone_number and account_contact_email details.
timezone
Optional
string The community's timezone. Must be a valid timezone identifier (E.g Africa/Johannesburg). The default timezone is UTC.
app_download_url
Optional
string The url this app can be downloaded from. Must be a valid URL. Max length of 255 characters.
default_country_calling_code
Optional
integer A default country calling code used in member phone number validation and selection.
hidden_notice_components
Optional
array List of notice components to NOT display when composing via Portal or apps. Used to avoid usage of specific components.

Returns

The newly created community object with status code 201 (Created).

Retrieve a Community

curl "https://relay-api.d6.co.za/api/business/v1/communities/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Retrieves a specific community.

Request

GET https://relay-api.d6.co.za/api/business/v1/communities/{id}

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Query Parameters

Parameter Description
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: apps, regions, plan.

Returns

The community object with status code 200 (OK).

Update a Community

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
          "name": "Updated Name"
         }'

Example Response:

{
  "id": "92f6ff6e-dbee-4408-a736-6a8d43ccaf3f",
  "name": "Updated Name",
  ...
  "created_at": "2021-03-16T11:50:55Z",
  "updated_at": "2021-04-01T10:03:08Z"
}

Updates a specific community. Only specified arguments will be changed, omitted arguments will remain unchanged.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}

Note: This endpoint uses POST rather than PUT so that multipart/form-data (E.g image uploads) is supported.

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Arguments (JSON)

Parameter Type Description
name
Optional
string The name of the community. Max length of 255 characters.
type
Optional
string Available types: 'school', 'club', 'business', 'other', 'unknown'.
tier_id
Optional
string The identifier (UUID) of the tier to move the community's plan to. These IDs will be provided to you.
short_name
Optional
string A short name for the community. Max length of 10 characters.
status
Optional
string The status of the community. Available types: 'active', 'closed'.
email
Optional
string The email address of the community. Must be a valid email address. Max length of 255 characters.
phone_number
Optional
string The phone number of the community. Max length of 255 characters.
website
Optional
string The website of the community. Must be a valid URL. Max length of 255 characters.
address
Optional
string The physical address of the community. Max length of 255 characters.
image
Optional
file The logo of the community. Used in email headers and within the apps.

Supported Formats:
jpg, png, gif, heic, heif

Max file size of 10MB.
cover_image
Optional
file The cover image of the community. Used in email headers and within the apps.

Supported Formats:
jpg, png, gif, heic, heif

Max file size of 10MB.
region_ids
Optional
array Array of Region IDs this community should be attached to. These IDs will be provided to you.

Hint: Previously submitted region_ids must be present in this array. If not they will be detached from the community.
locale
Optional
string The locale code (E.g en) of the community. Gets used for deciding the language to use throughout the service such as emails. Defaults to 'en'.
d6_unique_zoho_reference
Optional
string Internal usage. Must be unique across communities. Max length of 255 characters.
account_contact_name
Optional
string The name of the account contact. Max length of 255 characters.
account_contact_phone_number
Optional
string The phone number for this account's contact. Must be a valid mobile number.
account_contact_email
Optional
string The email address for this account's contact. Must be a valid email address. Max length of 255 characters.
account_contact_notes
Optional
string Additional notes for this account. This field can be used for malformed account_contact_phone_number and account_contact_email details.
timezone
Optional
string The community's timezone. Must be a valid timezone identifier (E.g Africa/Johannesburg). The default timezone is UTC.
app_download_url
Optional
string The url this app can be downloaded from. Must be a valid URL. Max length of 255 characters.
default_country_calling_code
Optional
integer A default country calling code used in member phone number validation and selection.
hidden_notice_components
Optional
array List of notice components to NOT display when composing via Portal or apps. Used to avoid usage of specific components.

Returns

The updated community object with status code 200 (OK).

Delete a Community

curl -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/communities/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "id": "92f6ff6e-dbee-4408-a736-6a8d43ccaf3f",
  "deleted": true
}

Deletes a specific community permanently. All data related to the community (notices, members etc.) will also be deleted.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/communities/{id}

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An object with an id and deleted attributes with status code 200 (OK).

List Communities

curl "https://relay-api.d6.co.za/api/business/v1/communities?page=1&per_page=20&sort=-name,created_at" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "data": [
    {
      "id": "92f6ff6e-dbee-4408-a736-6a8d43ccaf3f",
      "name": "Community Name 2",
      ...
      "created_at": "2017-09-29T09:53:21Z",
      "updated_at": "2017-09-29T09:53:21Z"
    },
    {
      "id": "12f6ff6e-dbee-4408-a736-6a8d43ccaf3d",
      "name": "Community Name",
      ...
      "created_at": "2017-09-22T08:29:00Z",
      "updated_at": "2017-09-22T08:29:00Z"
    }
  ],
  "pagination": {
    "total": 4,
    "count": 2,
    "per_page": 20,
    "current_page": 1,
    "total_pages": 2,
    "links": {
      "next": "http:\/\/relay-api.d6.co.za\/api\/business\/v1\/communities?page=2"
    }
  }
}

Returns a paginated list of all communities sorted by the most recently updated_at by default.

Request

GET https://relay-api.d6.co.za/api/business/v1/communities

Note: For situations where the query parameters are too long, a POST endpoint is also available that accepts the parameters in a JSON object: POST https://relay-api.d6.co.za/api/business/v1/communities/list

Query Parameters

Parameter Description
page
Optional
The page number to return (1-based). Defaults to 1.
per_page
Optional
The amount of communities to return per page. Defaults to 15.
sort
Optional
Comma separated string of properties to sort the communities by (ascending). Defaults to -updated_at.

Sortable Properties: name, type, status, status_at, source, email, phone_number, website, address, timezone, created_at, updated_at.

Hint: Adding a - before the property name will reverse the sort order to descending. E.g. Sort by name descending then by created_at ascending: ?sort=-name,created_at.
search
Optional
Case insensitive string to search and filter communities by name.
ids
Optional
Comma separated string of community IDs to filter.
region_ids
Optional
Comma separated string of region IDs to filter.
source
Optional
Filter communities by source. Available sources: 'manual', 'zoho'.
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: apps, regions, plan.

Returns

A data array of community objects as well as a pagination object with properties to keep track of the pagination. Status code: 200 (OK).

Suspend App Access

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/suspend-app" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "success": true
}

Suspend app access for a specific community. Users will stop seeing the community and its content across all apps this community is attached to.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/suspend-app

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An success object with status code 200 (OK).

Resume App Access

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/resume-app" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "success": true
}

Resume app access for a specific community.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/resume-app

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An success object with status code 200 (OK).

Suspend Portal Access

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/suspend-portal" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "success": true
}

Suspend portal access for a specific community. Users will not be able to perform any actions on the community management portal.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/suspend-portal

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An success object with status code 200 (OK).

Resume Portal Access

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/resume-portal" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "success": true
}

Resume portal access for a specific community.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/resume-portal

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An success object with status code 200 (OK).

Schedule Closure of Community

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/schedule-close" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json"
     -d '{
          "close_at": "2021-11-02T13:26:30+00:00"
        }'

Example Response:

{
  "success": true
}

Schedule the closure of a specific community for a provided date.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/schedule-close

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Arguments (JSON)

Parameter Type Description
close_at
Required
string Future date in ISO 8601 format on when to close the community.

Returns

An success object with status code 200 (OK).

Remove Any Scheduled Closure of a Community

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/remove-scheduled-close" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "success": true
}

Removes any scheduled closure of a specific community.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/remove-scheduled-close

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An success object with status code 200 (OK).

Lock Community Objects

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/lock" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "success": true
}

Creates a lock on all existing persons, community users, events, and channels which prevents portal system users from altering anything on the locked objects.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/lock

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An success object with status code 200 (OK).

Unlock Community Objects

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/communities/{id}/unlock" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "success": true
}

Removes any locks on all existing persons, community users, events, and channels.

Request

POST https://relay-api.d6.co.za/api/business/v1/communities/{id}/unlock

URL Parameters

Parameter Description
id The identifier of the community which was returned upon creation.

Returns

An success object with status code 200 (OK).

Community Users (Portal Users)

Community users refer to the community's management portal users.

Invite a Community User

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/community-users/invites" \
     -H 'Authorization: Bearer {ACCESS_TOKEN}' \
     -H 'Accept: application/json' \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "email": "example@d6.co.za",
            "community_roles": [
                "community_owner"
            ],
            "community_id": "bb60bd90-6973-3934-b165-5850c357ac68",
            "is_locked": true
        }'

Example Response:

{
  "id": "95829603-7d29-4eb4-a806-dc7a71976981",
  "community_id": "bb60bd90-6973-3934-b165-5850c357ac68",
  "email": "example@d6.co.za",
  "community_roles": [
    "community_owner"
  ],
  "channel_roles": [],
  "created_at": "2022-02-03T09:35:51Z",
  "updated_at": "2022-02-03T09:35:51Z",
  "is_locked": true
}

Invite a user to a specific community's management portal.

Request

POST https://relay-api.d6.co.za/api/business/v1/community-users/invites

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community that this community user belongs to.
email
Required
string The user's email address. Must be a valid email address. The invitation to access the specified community management portal will be sent to this email address.
community_roles
Optional
Array An array of community roles to be assigned to this community user.

Available Community Roles: community_owner, community_admin, all_channels_contributor, all_channels_moderator.
channel_roles
Optional
Array An array of objects, each containing a channel_id (required, must belong to the community) and a roles array of channel roles to be assigned to the community user for that channel.

Available Channel Roles: channel_moderator, channel_contributor.
is_locked
Optional
Boolean Whether to lock the related community_user object so that it can only be modified or deleted via the API. Defaults to true.

Returns

The newly created community_invite object with status code 201 (Created).

List Community Users Invites

curl "https://relay-api.d6.co.za/api/business/v1/community-users/invites" \
     -H 'Authorization: Bearer {ACCESS_TOKEN}' \
     -H 'Accept: application/json'

Example Response:

{
  "data": [
    {
      "id": "9560dbe2-9f44-408f-9f27-8a43f1934c6f",
      "community_id": "92f6fc67-fa40-4477-9709-5a93ad33067e",
      "email": "example@d6.co.za",
      "community_roles": [
        "community_owner"
      ],
      "channel_roles": [],
      "created_at": "2022-01-17T15:13:04Z",
      "updated_at": "2022-01-17T15:13:04Z",
      "is_locked": true
    },
    {
      "id": "95470ce7-47ce-4f63-9015-36c703419f81",
      "community_id": "951006d7-922a-4481-85f0-d91085255450",
      "email": "example2@d6.co.za",
      "community_roles": [
        "community_owner"
      ],
      "channel_roles": [],
      "created_at": "2022-01-04T19:18:37Z",
      "updated_at": "2022-01-04T19:18:37Z",
      "is_locked": true
    }
  ],
  "pagination": {
    "total": 2,
    "count": 2,
    "per_page": 15,
    "current_page": 1,
    "total_pages": 1,
    "links": []
  }
}

Returns a paginated list of all community users invites.

Note: Once an invite has been accepted by the user it will no longer be in this list.

Request

GET https://relay-api.d6.co.za/api/business/v1/community-users/invites

Note: For situations where the query parameters are too long, a POST endpoint is also available that accepts the parameters in a JSON object: POST https://relay-api.d6.co.za/api/business/v1/community-users/invites/list

Query Parameters

Parameter Description
sort
Optional
Comma separated string of properties to sort the community invites by (ascending). Defaults to -updated_at.

Sortable Properties: community_id, email, created_at, updated_at.

Hint: Adding a - before the property name will reverse the sort order to descending.
search
Optional
Case insensitive string to search and filter community invites by email (partial match).
page
Optional
The page number to return (1-based). Defaults to 1.
per_page
Optional
The amount of community invites to return per page. Defaults to 15. Maximum of 100.
ids
Optional
Comma separated string of community_invite IDs to filter.
community_ids
Optional
Comma separated string of community IDs to filter.

Returns

A data array of community_invite objects as well as a pagination object with properties to keep track of the pagination. Status code: 200 (OK).

Delete a Community User Invite

curl -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/community-users/invites/{id}" \
     -H 'Accept: application/json' \
     -H 'Authorization: Bearer {ACCESS_TOKEN}'

Example Response:

{
  "id": "95829603-7d29-4eb4-a806-dc7a71976981",
  "deleted": true
}

Delete a specific community user invite permanently.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/community-users/invites/{id}

URL Parameters

Parameter Description
id The identifier of the community_invite which was returned upon creation.

Returns

An object with an id and deleted attributes with status code 200 (OK).

Delete Multiple Community Users Invites

curl -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/community-users/invites" \
     -H 'Accept: application/json' \
     -H 'Authorization: Bearer {ACCESS_TOKEN}' \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
          "invite_ids": [
            "958ac459-efe7-4824-9ad4-e523eb89ee7d",
            "958ac431-bac1-48b9-9938-26e10a6d9836"
          ]
        }'

Example Response:

{
  "ids": [
    "958ac431-bac1-48b9-9938-26e10a6d9836",
    "958ac459-efe7-4824-9ad4-e523eb89ee7d"
  ],
  "deleted": true
}

Delete multiple community user invites permanently.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/community-users/invites

Arguments (JSON)

Parameter Type Description
invite_ids
Required
Array An array of invite IDs to be deleted.

Returns

An object with an ids and deleted attributes with status code 200 (OK).

Resend a Community User Invite

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/community-users/invites/{id}/resend" \
     -H 'Accept: application/json' \
     -H 'Authorization: Bearer {ACCESS_TOKEN}'

Example Response:

{
  "success": true
}

Resend a community invite to a user.

Request

POST https://relay-api.d6.co.za/api/business/v1/community-users/invites/{id}/resend

URL Parameters

Parameter Description
id The identifier of the community_invite which was returned upon creation.

Returns

A success object with status code 200 (OK).

Update a Community User

curl    -X "PUT" "https://relay-api.d6.co.za/api/business/v1/community-users/{id}" \
        -H 'Accept: application/json' \
        -H 'Authorization: Bearer {ACCESS_TOKEN}' \
        -H 'Accept-Language: ' \
        -H 'Content-Type: application/json; charset=utf-8' \
        -d $'{
            "channel_roles": [
                {
                    "roles": [
                        "channel_contributor",
                        "channel_moderator"
                    ],
                    "channel_id": "9580e5bf-9766-417a-9545-116656cb10e9"
                }
            ],
            "community_roles": [
                "community_owner"
            ],
            "community_id": "bb60bd90-6973-3934-b165-5850c357ac68",
            "is_locked": true
        }'

Example Response:

{
  "id": "85890309-27fc-4e4b-85b6-130fbe329c20",
  "email": "example@d6.co.za",
  "phone_number": "+27662449755",
  "first_name": "Eulalia",
  "last_name": "Gleichner",
  "communities": [
    {
      "id": "bb60bd90-6973-3934-b165-5850c357ac68",
      "community_roles": [
        "community_owner"
      ],
      "channel_roles": {
        "9580e5bf-9766-417a-9545-116656cb10e9": [
          "channel_contributor",
          "channel_moderator"
        ]
      },
      "is_locked": true
    }
  ],
  "created_at": "2022-01-26T09:10:56Z",
  "updated_at": "2022-01-26T09:10:58Z"
}

Updates a specific community user. Only specified arguments will be changed, omitted arguments will remain unchanged.

Request

PUT https://relay-api.d6.co.za/api/business/v1/community-users/{id}

URL Parameters

Parameter Description
id The identifier of the community_user which was returned upon creation.

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community that this community user belongs to.
community_roles
Optional
Array An array of community roles to be assigned to this community user.

Available Community Roles:community_owner, community_admin, all_channels_contributor, all_channels_moderator.
channel_roles
Optional
Array An array of objects, each containing a channel_id (required, must belong to the community) and a roles array (required) of roles to be assigned to the community_user for that channel.

Available Channel Roles: channel_moderator, channel_contributor.
is_locked
Optional
Boolean Whether to lock the related community_user object so that it can only be modified or deleted via the API. Defaults to true.
first_name
Optional
string The user's first name. Max length of 255 characters.
last_name
Optional
string The user's last name. Max length of 255 characters.
email
Optional
string The user's email address. Must be a valid email address. Max length of 255 characters.
phone_number
Optional
string The user's phone number. Max length of 20 characters.

Returns

The updated community_user object with status code 200 (OK).

Detach a Community User

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/community-users/{id}/detach" \
     -H 'Accept: application/json' \
     -H 'Authorization: Bearer {ACCESS_TOKEN}' \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "community_id": "4b82bb39-4a1c-3c9d-a882-8a291b8715a8"
        }'

Example Response:

{
  "success": true   
}

Detach a user from a specific community. The user will no longer have access to the community management portal.

Request

POST https://relay-api.d6.co.za/api/business/v1/community-users/{id}/detach

URL Parameters

Parameter Description
id The identifier of the community_user which was returned upon creation.

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community this user will be detached from.

Returns

A success object with status code 200 (OK).

Detach Multiple Community Users

curl    -X "POST" "https://relay-api.d6.co.za/api/business/v1/community-users/detach" \
        -H 'Accept: application/json' \
        -H 'Authorization: Bearer {ACCESS_TOKEN}' \
        -H 'Content-Type: application/json; charset=utf-8' \
        -d $'{
            "user_ids": [
                "d32fed5e-6d7b-3c30-bda9-f05e373b5405",
                "a9c08733-2258-35e3-8143-3e3745b42631"
            ],
            "community_id": "bb60bd90-6973-3934-b165-5850c357ac68"
        }'

Example Response:

{
  "success": true   
}

Detach multiple users from a specific community. The users will no longer have access to the community management portal.

Request

POST https://relay-api.d6.co.za/api/business/v1/community-users/detach

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community that users will be detached from.
user_ids
Required
Array An array of user IDs to be detached from the specified community.

Returns

A success object with status code 200 (OK).

List Community Users

curl "https://relay-api.d6.co.za/api/business/v1/community-users?sort=first_name&page=1&per_page=3" \
     -H 'Authorization: Bearer {ACCESS_TOKEN}' \
     -H 'Accept: application/json'

Example Response:

{
  "data": [
    {
      "id": "1284ef82-7f44-3439-a10c-088fd4b6eef2",
      "email": "example@d6.co.za",
      "phone_number": "+6326943009478",
      "first_name": "Glennie",
      "last_name": "Pagac",
      "communities": [
        {
          "id": "bb60bd90-6973-3934-b165-5850c357ac68",
          "community_roles": [],
          "channel_roles": {
            "5c95eebc-3d22-3b7d-8c71-3cf153b307e1": [
              "channel_moderator"
            ]
          },
          "is_locked": true
        }
      ],
      "created_at": "2022-01-26T09:10:58Z",
      "updated_at": "2022-01-26T09:10:58Z"
    }
  ],
  "pagination": {
    "total": 1,
    "count": 1,
    "per_page": 15,
    "current_page": 1,
    "total_pages": 1,
    "links": []
  }
}

Returns a paginated list of all community users sorted by the most recently updated_at by default.

Request

GET https://relay-api.d6.co.za/api/business/v1/community-users

Note: For situations where the query parameters are too long, a POST endpoint is also available that accepts the parameters in a JSON object: POST https://relay-api.d6.co.za/api/business/v1/community-users/list

Query Parameters

Parameter Description
sort
Optional
Comma separated string of properties to sort the community users by (ascending). Defaults to -updated_at.

Sortable Properties: first_name, last_name, email, phone_number, created_at, updated_at.

Hint: Adding a - before the property name will reverse the sort order to descending.
search
Optional
Case insensitive string to search and filter community users by first_name or last_name.
page
Optional
The page number to return (1-based). Defaults to 1.
per_page
Optional
The amount of community users to return per page. Defaults to 15. Maximum of 100.
ids
Optional
Comma separated string of community_user IDs to filter.
community_ids
Optional
Comma separated string of community IDs to filter.
community_roles
Optional
Comma separated string of community_roles to filter.

Available Community Roles: community_owner, community_admin, all_channels_contributor, all_channels_moderator.
channel_roles
Optional
Comma separated string of channel_roles to filter.

Available Channel Roles: channel_moderator, channel_contributor.

Returns

A data array of community_users objects as well as a pagination object with properties to keep track of the pagination. Status code: 200 (OK).

Contacts

Contacts are visible within the app as your typical "phone book" contacts. All contacts are visible to any user who is part of the community. Contacts can be used to share general contact information of a community.

Example: Creating a Mrs van Zyl - School Secretary contact with email and phone_number which users in the app will be able to save to their device phone book.

Contacts are accessible within the app in the "Contact Community" section located in the side menu.

Create a Contact

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/contacts" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
            "first_name": "Merike",
            "last_name": "van Zyl",
            "prefix": "Mrs",
            "title": "Secretary",
            "birthday": "24-07-1990",
            "org": "St Paulus Primary School",
            "facebook_url": "https://www.facebook.com/theurl",
            "twitter_url": "https://twitter.com/theurl",
            "note": "The secretary to the Principal.",
            "work_emails": [
                "m.vanzyl@example.org"
            ],
            "home_emails": [],
            "work_telephones": [],
            "home_telephones": [
                "+2751511151"
            ]
        }'

Example Response:

{
    "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
    "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
    "first_name": "Merike",
    "last_name": "van Zyl",
    "prefix": "Mrs",
    "title": "Secretary",
    "middle_name": null,
    "birthday": "1990-07-24",
    "org": "St Paulus Primary School",
    "facebook_url": "https://www.facebook.com/theurl",
    "twitter_url": "https://twitter.com/theurl",
    "note": "The secretary to the Principal.",
    "work_emails": [
        "m.vanzyl@example.org"
    ],
    "home_emails": [],
    "work_telephones": [],
    "home_telephones": [
        "+2751511151"
    ],
    "vcard": "BEGIN:VCARD\r\nVERSION:3.0\r\n...\r\nEND:VCARD",
    "created_at": "2021-03-16T11:50:55Z",
    "updated_at": "2021-04-01T08:03:08Z"
}

Creates a new contact.

Request

POST https://relay-api.d6.co.za/api/business/v1/contacts

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community that this contact belongs to.
prefix
Optional
string The prefix of the contact. Max length of 255 characters.
first_name
Optional
string The first name of the contact. Max length of 255 characters.
middle_name
Optional
string The middle name of the contact. Max length of 255 characters.
last_name
Optional
string The last name of the contact. Max length of 255 characters.
title
Optional
string The title/role of the contact (E.g Secretary). Max length of 255 characters.
birthday
Optional
string The birthday of the contact (Format: DD-MM-YYYY).
org
Optional
string The organisation name the contact belongs to. Max length of 255 characters.
work_emails
Optional
array Array of work email addresses. Each must be a valid email address.
home_emails
Optional
array Array of home/personal email addresses. Each must be a valid email address.
home_telephones
Optional
array Array of home/personal telephone number strings preferably in E.164 format. Max length of 255 characters each.
work_telephones
Optional
array Array of work telephone number strings preferably in E.164 format. Max length of 255 characters each.
note
Optional
string Notes/description of the contact. Max length of 255 characters.
facebook_url
Optional
string URL to the contact's Facebook page. Must be a valid URL. Max length of 255 characters.
twitter_url
Optional
string URL to the contact's Twitter page. Must be a valid URL. Max length of 255 characters.

Returns

The newly created contact object with status code 201 (Created).

Retrieve a Contact

curl "https://relay-api.d6.co.za/api/business/v1/contacts/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Retrieves a specific contact.

Request

GET https://relay-api.d6.co.za/api/business/v1/contacts/{id}

URL Parameters

Parameter Description
id The identifier of the contact which was returned upon creation.

Returns

The contact object with status code 200 (OK).

Update a Contact

curl -X "PUT" "https://relay-api.d6.co.za/api/business/v1/contacts/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
          "first_name": "Updated Name"
         }'

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "first_name": "Updated First Name",
  ...
  "created_at": "2021-03-16T11:50:55Z",
  "updated_at": "2021-04-01T10:03:08Z"
}

Updates a specific contact. Only specified arguments will be changed, ommitted arguments will remain unchanged.

Request

PUT https://relay-api.d6.co.za/api/business/v1/contacts/{id}

URL Parameters

Parameter Description
id The identifier of the contact which was returned upon creation.

Arguments (JSON)

Parameter Type Description
prefix
Optional
string The prefix of the contact. Max length of 255 characters.
first_name
Optional
string The first name of the contact. Max length of 255 characters.
middle_name
Optional
string The middle name of the contact. Max length of 255 characters.
last_name
Optional
string The last name of the contact. Max length of 255 characters.
title
Optional
string The title/role of the contact (E.g Secretary). Max length of 255 characters.
birthday
Optional
string The birthday of the contact (Format: DD-MM-YYYY).
org
Optional
string The organisation name the contact belongs to. Max length of 255 characters.
work_emails
Optional
array Array of work email addresses. Each must be a valid email address.
home_emails
Optional
array Array of home/personal email addresses. Each must be a valid email address.
home_telephones
Optional
array Array of home/personal telephone number strings preferably in E.164 format. Max length of 255 characters each.
work_telephones
Optional
array Array of work telephone number strings preferably in E.164 format. Max length of 255 characters each.
note
Optional
string Notes/description of the contact. Max length of 255 characters.
facebook_url
Optional
string URL to the contact's Facebook page. Must be a valid URL. Max length of 255 characters.
twitter_url
Optional
string URL to the contact's Twitter page. Must be a valid URL. Max length of 255 characters.

Returns

The updated contact object with status code 200 (OK).

Delete a Contact

curl -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/contacts/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "deleted": true
}

Deletes a specific contact permanently.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/contacts/{id}

URL Parameters

Parameter Description
id The identifier of the contact which was returned upon creation.

Returns

An object with an id and deleted attributes with status code 200 (OK).

List Contacts

curl "https://relay-api.d6.co.za/api/business/v1/contacts?page=1&per_page=20&sort=-first_name,created_at" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "data": [
    {
      "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
      "first_name": "Merike",
      ...
      "created_at": "2017-09-29T09:53:21Z",
      "updated_at": "2017-09-29T09:53:21Z"
    },
    {
      "id": "12f6ff6e-dbee-4408-a736-6a8d43ccaf3d",
      "first_name": "Alan",
      ...
      "created_at": "2017-09-22T08:29:00Z",
      "updated_at": "2017-09-22T08:29:00Z"
    }
  ],
  "pagination": {
    "total": 4,
    "count": 2,
    "per_page": 20,
    "current_page": 1,
    "total_pages": 2,
    "links": {
      "next": "http:\/\/relay-api.d6.co.za\/api\/business\/v1\/contacts?page=2"
    }
  }
}

Returns a paginated list of all contacts sorted by the most recently updated_at by default.

Request

GET https://relay-api.d6.co.za/api/business/v1/contacts

Note: For situations where the query parameters are too long, a POST endpoint is also available that accepts the parameters in a JSON object: POST https://relay-api.d6.co.za/api/business/v1/contacts/list

Query Parameters

Parameter Description
page
Optional
The page number to return (1-based). Defaults to 1.
per_page
Optional
The amount of contacts to return per page. Defaults to 15.
sort
Optional
Comma separated string of properties to sort the contacts by (ascending). Defaults to -updated_at.

Sortable Properties: community_id, prefix, first_name, middle_name, last_name, title, birthday, org, created_at, updated_at.

Hint: Adding a - before the property name will reverse the sort order to descending. E.g. Sort by first_name descending then by created_at ascending: ?sort=-first_name,created_at.
search
Optional
Case insensitive string to search and filter contacts by first_name or last_name.
ids
Optional
Comma separated string of contact IDs to filter.
community_ids
Optional
Comma separated string of community IDs to filter.
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: community.

Returns

A data array of contact objects as well as a pagination object with properties to keep track of the pagination. Status code: 200 (OK).

Tags

Tags can be used to add metadata on person and channel objects. Tags also allow more coarse-grained access control to channels. Tags can also be used to enrich data on your community members for later use.

Example: Creating a Staff tag, attaching that tag to multiple persons in the community and then creating a Staff Only channel with a Staff tag. Now only those person objects with Staff tags can access the that channel.

Example 2: Filtering on the list persons endpdoint using tag_ids.

Tags are community specific and are visible to all system users of that community.

Create a Tag

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/tags" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
            "name": "Staff"
        }'

Example Response:

{
    "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
    "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
    "name": "Staff",
    "created_at": "2021-03-16T11:50:55Z",
    "updated_at": "2021-04-01T08:03:08Z"
}

Creates a new tag.

Request

POST https://relay-api.d6.co.za/api/business/v1/tags

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community that this tag belongs to.
name
Required
string The name of the tag. Max length of 255 characters.

Returns

The newly created tag object with status code 201 (Created).

Retrieve a Tag

curl "https://relay-api.d6.co.za/api/business/v1/tags/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Retrieves a specific tag.

Request

GET https://relay-api.d6.co.za/api/business/v1/tags/{id}

URL Parameters

Parameter Description
id The identifier of the tag which was returned upon creation.

Returns

The tag object with status code 200 (OK).

Update a Tag

curl -X "PUT" "https://relay-api.d6.co.za/api/business/v1/tags/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
          "name": "Updated Name"
         }'

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "name": "Updated Name",
  ...
  "created_at": "2021-03-16T11:50:55Z",
  "updated_at": "2021-04-01T10:03:08Z"
}

Updates a specific tag. Only specified arguments will be changed, ommitted arguments will remain unchanged.

Request

PUT https://relay-api.d6.co.za/api/business/v1/tags/{id}

URL Parameters

Parameter Description
id The identifier of the tag which was returned upon creation.

Arguments (JSON)

Parameter Type Description
name
Optional
string The name of the tag. Max length of 255 characters.

Returns

The updated tag object with status code 200 (OK).

Delete a Tag

curl -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/tags/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "deleted": true
}

Deletes a specific tag permanently.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/tags/{id}

URL Parameters

Parameter Description
id The identifier of the tag which was returned upon creation.

Returns

An object with an id and deleted attributes with status code 200 (OK).

List Tags

curl "https://relay-api.d6.co.za/api/business/v1/tags?page=1&per_page=20&sort=-name,created_at" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "data": [
    {
      "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
      "name": "Tag Name 2",
      ...
      "created_at": "2017-09-29T09:53:21Z",
      "updated_at": "2017-09-29T09:53:21Z"
    },
    {
      "id": "12f6ff6e-dbee-4408-a736-6a8d43ccaf3d",
      "name": "Tag Name",
      ...
      "created_at": "2017-09-22T08:29:00Z",
      "updated_at": "2017-09-22T08:29:00Z"
    }
  ],
  "pagination": {
    "total": 4,
    "count": 2,
    "per_page": 20,
    "current_page": 1,
    "total_pages": 2,
    "links": {
      "next": "http:\/\/relay-api.d6.co.za\/api\/business\/v1\/tags?page=2"
    }
  }
}

Returns a paginated list of all tags sorted by the most recently updated_at by default.

Request

GET https://relay-api.d6.co.za/api/business/v1/tags

Note: For situations where the query parameters are too long, a POST endpoint is also available that accepts the parameters in a JSON object: POST https://relay-api.d6.co.za/api/business/v1/tags/list

Query Parameters

Parameter Description
page
Optional
The page number to return (1-based). Defaults to 1.
per_page
Optional
The amount of tags to return per page. Defaults to 15.
sort
Optional
Comma separated string of properties to sort the tags by (ascending). Defaults to -updated_at.

Sortable Properties: community_id, name, created_at, updated_at.

Hint: Adding a - before the property name will reverse the sort order to descending. E.g. Sort by name descending then by created_at ascending: ?sort=-name,created_at.
search
Optional
Case insensitive string to search and filter tags by name.
ids
Optional
Comma separated string of tag IDs to filter.
community_ids
Optional
Comma separated string of community IDs to filter.

Returns

A data array of tag objects as well as a pagination object with properties to keep track of the pagination. Status code: 200 (OK).

Persons

Persons refer to members of a specific community or in other words, the community communication contact list.

Create a Person

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/persons" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
            "first_name": "Leroy",
            "last_name": "Jenkins",
            "unique_identifier" : "AB-122",
            "email" : "person@example.org",
            "phone_number": "+2761124222"
        }'

Example Response:

{
    "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
    "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
    "is_public_follower": false,
    "unique_identifier": "AB-122",
    "first_name": "Leroy",
    "last_name": "Jenkins",
    "email": "person@example.org",
    "phone_number": "+2761124222",
    "id_number": null,
    "app_last_seen_at": null,
    "last_seen_at_chatbot_whatsapp": null,
    "last_seen_at_chatbot_app": null,
    "last_seen_at_chatbot": null,
    "created_at": "2021-03-16T11:50:55Z",
    "updated_at": "2021-04-01T08:03:08Z",
    "is_locked": false,
    "debtor_reference": null
}

Creates a new person.

Request

POST https://relay-api.d6.co.za/api/business/v1/persons

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community that this person belongs to.
first_name
Optional
string The first name of the person. Max length of 255 characters.
last_name
Optional
string The last name of the person. Max length of 255 characters.
unique_identifier
Optional
string A unique identifier for your internal use (E.g Employee number). Must be unique within the community. Max length of 255 characters.
email
Optional
string The email address of the person. Must be a valid email address. Max length of 255 characters.
phone_number
Optional
string The mobile phone number of the person. Format: E.164 (E.g +27000000000)
id_number
Optional
string The ID or passport number of the person. Max length of 255 characters.
debtor_reference
Optional
string The debtor reference of the person. Max length of 255 characters.
channel_ids
Optional
array Array of channel IDs this person should be attached to on creation. Channels must belong to the community.
tag_ids
Optional
array Array of tag IDs this person should be attached to on creation. Tags must belong to the community.
update_app_channel_subscriptions
Optional
boolean Whether any app users linked to this person should have any channels subscribed on their behalf depending on the channel_ids and tag_ids attributes. Defaults to true.
notify_subscription_changes_via_app
Optional
boolean If update_app_channel_subscriptions is true, whether app users should receive a notification about these channel subscriptions that happened on their behalf. Defaults to false.
update_app_community_subscriptions
Optional
boolean Whether any app users linked to this person should be automatically subscribed to the community, if not already subscribed. Defaults to true.
notify_community_subscription_changes_via_app
Optional
boolean If update_app_community_subscriptions is true, whether app users should receive a notification about the community subscription that happened on their behalf. Defaults to true.
parent_person_ids
Optional
array An array of parent Person IDs this person should be attached to. Persons must belong to the community.
child_person_ids
Optional
array An array of child Person IDs this person should be attached to. Persons must belong to the community.
is_locked
Optional
boolean Whether to lock this person so that only the API can make further changes to the object. Defaults to false.
expand
Optional
string Comma separated string of relationships to include in the response.

Expandable Relationships: community, channels, tags, parents, children.

Returns

The newly created person object with status code 201 (Created).

Retrieve a Person

curl "https://relay-api.d6.co.za/api/business/v1/persons/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Retrieves a specific person.

Request

GET https://relay-api.d6.co.za/api/business/v1/persons/{id}

URL Parameters

Parameter Description
id The identifier of the person which was returned upon creation.

Query Parameters

Parameter Description
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: community, channels, tags, parents, children.

Returns

The person object with status code 200 (OK).

Update a Person

curl -X "PUT" "https://relay-api.d6.co.za/api/business/v1/persons/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
          "email": "updated@example.org"
         }'

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  ...
  "email": "updated@example.org",
  ...
  "created_at": "2021-03-16T11:50:55Z",
  "updated_at": "2021-04-01T10:03:08Z"
}

Updates a specific person. Only specified arguments will be changed, ommitted arguments will remain unchanged.

Request

PUT https://relay-api.d6.co.za/api/business/v1/persons/{id}

URL Parameters

Parameter Description
id The identifier of the person which was returned upon creation.

Arguments (JSON)

Parameter Type Description
first_name
Optional
string The first name of the person. Max length of 255 characters.
last_name
Optional
string The last name of the person. Max length of 255 characters.
unique_identifier
Optional
string A unique identifier for your internal use (E.g Employee number). Must be unique within the community. Max length of 255 characters.
email
Optional
string The email address of the person. Must be a valid email address. Max length of 255 characters. Nullable.
phone_number
Optional
string The mobile phone number of the person. Format: E.164 (E.g +27000000000). Nullable.
id_number
Optional
string The ID or passport number of the person. Max length of 255 characters.
debtor_reference
Optional
string The debtor reference of the person. Max length of 255 characters.
channel_ids
Optional
array Array of channel IDs this person should be attached to. Replaces the existing channel attachments. Channels must belong to the person's community.
tag_ids
Optional
array Array of tag IDs this person should be attached to. Replaces the existing tag attachments. Tags must belong to the person's community.
update_app_channel_subscriptions
Optional
boolean Whether any app users linked to this person should have any channels subscribed/unsubscribed on their behalf depending on the channel_ids and tag_ids attributes. Defaults to true.
notify_subscription_changes_via_app
Optional
boolean If update_app_channel_subscriptions is true, whether app users should receive a notification about these channel subscriptions/unsubscriptions that happened on their behalf. Defaults to false.
update_app_community_subscriptions
Optional
boolean Whether any app users linked to this person should be automatically subscribed to the community, if not already subscribed. Defaults to false.
notify_community_subscription_changes_via_app
Optional
boolean If update_app_community_subscriptions is true, whether app users should receive a notification about the community subscription that happened on their behalf. Defaults to true.
parent_person_ids
Optional
array An array of parent Person IDs this person should be attached to.
child_person_ids
Optional
array An array of child Person IDs this person should be attached to.
is_locked
Optional
boolean Whether to lock this person so that only the API can make further changes to the object.
convert_to_public_follower_instead_of_detaching
Optional
boolean When channels are removed via channel_ids, whether the person should be converted to a public follower of those channels instead of being detached. Defaults to false for third-party clients and true for first-party clients.
expand
Optional
string Comma separated string of relationships to include in the response.

Expandable Relationships: community, channels, tags, parents, children.

Returns

The updated person object with status code 200 (OK).

Delete a Person

curl -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/persons/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "deleted": true
}

Deletes a specific person permanently.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/persons/{id}

URL Parameters

Parameter Description
id The identifier of the person which was returned upon creation.

Arguments (JSON)

Parameter Type Description
notify_community_subscription_changes_via_app
Optional
boolean Whether app users linked to this person should receive a notification about the community unsubscription that happened on their behalf. Defaults to false.

Returns

An object with an id and deleted attributes with status code 200 (OK).

Delete Multiple Persons

curl  -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/persons" \
      -H "Authorization: Bearer {ACCESS_TOKEN}" \
      -H "Accept: application/json" \
      -H 'Content-Type: application/json; charset=utf-8' \
      -d $'{
            "person_ids": [
              "9a2bb989-f1be-3a46-8748-2667a166074b",
              "67a2ea04-decb-3f66-b619-cfde929669c0"
            ]
          }'

Example Response:

{
  "ids": [
    "9a2bb989-f1be-3a46-8748-2667a166074b",
    "67a2ea04-decb-3f66-b619-cfde929669c0"
  ],
  "deleted": true
}

Deletes specified persons permanently.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/persons

Arguments (JSON)

Parameter Type Description
person_ids
Required
array Array of person IDs that were returned upon creation.
notify_community_subscription_changes_via_app
Optional
boolean Whether app users linked to these persons should receive a notification about the community unsubscription that happened on their behalf. Defaults to value of notify_subscription_changes_via_app (which defaults to false).

Returns

An object with an ids and deleted attributes with status code 200 (OK).

List Persons

curl "https://relay-api.d6.co.za/api/business/v1/persons?page=1&per_page=20&sort=-first_name,created_at" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "data": [
    {
      "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
      "first_name": "Zelda",
      ...
      "created_at": "2017-09-29T09:53:21Z",
      "updated_at": "2017-09-29T09:53:21Z"
    },
    {
      "id": "12f6ff6e-dbee-4408-a736-6a8d43ccaf3d",
      "first_name": "Nuah",
      ...
      "created_at": "2017-09-22T08:29:00Z",
      "updated_at": "2017-09-22T08:29:00Z"
    }
  ],
  "pagination": {
    "total": 4,
    "count": 2,
    "per_page": 20,
    "current_page": 1,
    "total_pages": 2,
    "links": {
      "next": "http:\/\/relay-api.d6.co.za\/api\/business\/v1\/persons?page=2"
    }
  }
}

Returns a paginated list of all persons sorted by the most recently updated_at by default.

Request

GET https://relay-api.d6.co.za/api/business/v1/persons

Note: For situations where the query parameters are too long, a POST endpoint is also available that accepts the parameters in a JSON object: POST https://relay-api.d6.co.za/api/business/v1/persons/list

Query Parameters

Parameter Description
page
Optional
The page number to return (1-based). Defaults to 1.
per_page
Optional
The amount of persons to return per page. Defaults to 15.
sort
Optional
Comma separated string of properties to sort the persons by (ascending). Defaults to -updated_at.

Sortable Properties: first_name, last_name, unique_identifier, email, phone_number, id_number, app_last_seen_at, last_invited_app_at, last_seen_at_chatbot_whatsapp, last_seen_at_chatbot_app, created_at, updated_at.

Hint: Adding a - before the property name will reverse the sort order to descending. E.g. Sort by first_name descending then by created_at ascending: ?sort=-first_name,created_at.
search
Optional
Case insensitive string to search and filter persons by. Matches (partially) against first name, last name, full name, phone number, email, ID number, unique identifier and debtor reference, or exactly against the person ID. Multiple search terms can be comma separated.
ids
Optional
Comma separated string of person IDs to filter.
community_ids
Optional
Comma separated string of community IDs to filter.
channel_ids
Optional
Comma separated string of channel IDs to filter.
tag_ids
Optional
Comma separated string of tag IDs to filter.
unique_identifier
Optional
Filter persons by an exact unique_identifier match.
debtor_reference
Optional
Filter persons by an exact debtor_reference match.
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: community, channels, tags, parents, children.

Returns

A data array of person objects as well as a pagination object with properties to keep track of the pagination. Status code: 200 (OK).

Channels

Channels can be used to group specific persons for repeatable targeting. If configured so, they can also be joined by your community members via the app.

Example: Creating a Grade 1 Parents channel which only parents of Grade 1 children can join or a General Announcements channel which anyone can join.

A channel can also be expired once it has served its purpose. An expired channel keeps all of its content visible to its existing members in the app, but can no longer be joined, left, or targeted with new notices, and is hidden from the app's channel lists. Expiry is reversible; deleting remains the only way to remove a channel and its content. Set expires_at to have a channel expire automatically on a date, or use the expire endpoint to do it immediately.

Create a Channel

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/channels" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
            "name": "Grade 1 Parents",
            "invite_only": true,
            "is_hidden" : false,
            "is_default" : false,
            "can_leave": false
        }'

Example Response:

{
    "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
    "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
    "name": "Grade 1 Parents",
    "type": null,
    "invite_only": true,
    "is_hidden": false,
    "is_default": false,
    "can_leave": false,
    "created_at": "2021-03-16T11:50:55Z",
    "updated_at": "2021-04-01T08:03:08Z",
    "is_locked": false,
    "is_visible_for_selection": true,
    "integrations_d6_plus_channel": false,
    "integrations_d6_plus_channel_id": null,
    "is_temporary": false,
    "is_expired": false,
    "expired_at": null,
    "expires_at": null,
    "expiry_reason": null,
    "expired_by_rollover_id": null
}

Creates a new channel.

Request

POST https://relay-api.d6.co.za/api/business/v1/channels

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier (UUID) of the community that this channel belongs to.
name
Required
string The name of the channel. Max length of 255 characters.
type
Optional
string The category of the channel. Available types: grade, register_class, subject, house, boarding, campus, division, department, sports_team, cultural_group, supporters, staff, committee, parent_group, learner_group, announcement, ad_hoc, unspecified.
invite_only
Optional
boolean Whether the channel can be joined by users themselves (E.g via app). Note: tag_ids and person_ids taken into account.
is_hidden
Optional
boolean Whether the channel is visible to app users.
is_default
Optional
boolean When a user subscribes to the community, the channel will automatically be added to the user's subscribed channels. Example: The General Announcements channel must be attached to all new users. Note: tag_ids and person_ids taken into account.
can_leave
Optional
boolean Whether users can unsubscribe/leave the channel themselves (E.g via app).
tag_ids
Optional
array Array of Tag IDs this channel should be associated with. This then controls who can join/subscribe to the channel. Example: Attaching a Parent tag to the channel will only allow community members with the Parent tag to join/subscribe to the channel.
person_ids
Optional
array Array of Person IDs this channel should be associated with. This then controls who specifically can join the channel.
update_app_channel_subscriptions
Optional
boolean Whether any app users that are associated to this channel (either via tag or directly attached via person_ids) should be subscribed/unsubscribed to the channel on their behalf. Defaults to true.
notify_subscription_changes_via_app
Optional
boolean If update_app_channel_subscriptions is true, whether app users should receive a notification about these channel subscriptions/unsubscriptions that happened on their behalf. Defaults to false.
is_locked
Optional
boolean Whether to lock this channel so that only the API can make further changes to the object.
is_visible_for_selection
Optional
boolean Whether the channel appears in selection lists. Defaults to true on create.
attach_all_persons_in_community
Optional
boolean Immediately attach all persons in the community to the channel, regardless of tag_ids/person_ids rules. Defaults to false.
attach_persons_with_tag_ids
Optional
array Array of Tag IDs. Immediately attach all persons with any of these tags to the channel.
attach_persons_with_ids
Optional
array Array of Person IDs to immediately attach to the channel.
expires_at
Optional
string ISO 8601 date and time at which this channel should automatically expire. A channel with an expires_at is a temporary channel. Send null to cancel a pending expiry. Omitting this argument leaves any existing value unchanged. A date in the past is accepted and will be actioned within a minute.

Returns

The newly created channel object with status code 201 (Created).

Retrieve a Channel

curl "https://relay-api.d6.co.za/api/business/v1/channels/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Retrieves a specific channel.

Request

GET https://relay-api.d6.co.za/api/business/v1/channels/{id}

URL Parameters

Parameter Description
id The identifier of the channel which was returned upon creation.

Query Parameters

Parameter Description
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: community, tags, persons.

Returns

The channel object with status code 200 (OK).

Update a Channel

curl -X "PUT" "https://relay-api.d6.co.za/api/business/v1/channels/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
          "name": "Updated Name"
         }'

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "name": "Updated Name",
  ...
  "created_at": "2021-03-16T11:50:55Z",
  "updated_at": "2021-04-01T10:03:08Z"
}

Updates a specific channel. Only specified arguments will be changed, ommitted arguments will remain unchanged.

Request

PUT https://relay-api.d6.co.za/api/business/v1/channels/{id}

URL Parameters

Parameter Description
id The identifier of the channel which was returned upon creation.

Arguments (JSON)

Parameter Type Description
name
Optional
string The name of the channel. Max length of 255 characters.
type
Optional
string The category of the channel. Available types: grade, register_class, subject, house, boarding, campus, division, department, sports_team, cultural_group, supporters, staff, committee, parent_group, learner_group, announcement, ad_hoc, unspecified.
invite_only
Optional
boolean Whether the channel can be joined by users themselves (E.g via app). Note: tag_ids and person_ids taken into account.
is_hidden
Optional
boolean Whether the channel is visible to app users.
is_default
Optional
boolean When a user subscribes to the community, the channel will automatically be added to the user's subscribed channels. Example: The General Announcements channel must be attached to all new users. Note: tag_ids and person_ids taken into account.
can_leave
Optional
boolean Whether users can unsubscribe/leave the channel themselves (E.g via app).
tag_ids
Optional
array Array of Tag IDs this channel should be associated with. This then controls who can join/subscribe to the channel. Example: Attaching a Parent tag to the channel will only allow community members with the Parent tag to join/subscribe to the channel.
person_ids
Optional
array Array of Person IDs this channel should be associated with. This then controls who specifically can join the channel.
update_app_channel_subscriptions
Optional
boolean Whether any app users that are associated to this channel (either via tag or directly attached via person_ids) should be subscribed/unsubscribed to the channel on their behalf. Defaults to true.
notify_subscription_changes_via_app
Optional
boolean If update_app_channel_subscriptions is true, whether app users should receive a notification about these channel subscriptions/unsubscriptions that happened on their behalf. Defaults to false.
is_locked
Optional
boolean Whether to lock this channel so that only the API can make further changes to the object.
is_visible_for_selection
Optional
boolean Whether the channel appears in selection lists.
expires_at
Optional
string ISO 8601 date and time at which this channel should automatically expire. A channel with an expires_at is a temporary channel. Send null to cancel a pending expiry. Omitting this argument leaves any existing value unchanged. A date in the past is accepted and will be actioned within a minute.

Returns

The updated channel object with status code 200 (OK).

Expire a Channel

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/channels/{id}/expire" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "expired": true,
  "expired_at": "2026-09-04T08:12:44Z"
}

Expires a specific channel immediately.

The channel keeps all of its content: its notices, events and payments stay visible to its existing members in the app, and its members and their app subscriptions are left untouched. What changes is that the channel is hidden from the app's channel lists, can no longer be joined or left, its membership can no longer be modified, and it can no longer be targeted by new notices. If the channel had chat enabled, the conversation becomes read-only history.

Sets expiry_reason to manual. To have a channel expire automatically on a date instead, set expires_at on create or update.

Request

POST https://relay-api.d6.co.za/api/business/v1/channels/{id}/expire

URL Parameters

Parameter Description
id The identifier of the channel which was returned upon creation.

Returns

An object with id, expired and expired_at attributes with status code 200 (OK).

Attempting to expire a channel that is already expired returns 400 (Bad Request) with error code 1220.

Unexpire a Channel

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/channels/{id}/unexpire" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "expired": false,
  "expired_at": null
}

Removes the expiry from a specific channel, returning it to normal. Because expiry never removed the channel's members, it comes back with its membership intact.

Also clears expiry_reason. A pending expires_at that is already in the past is cleared too, so the channel is not immediately expired again; an expires_at still in the future is deliberately kept.

This endpoint is idempotent — calling it on a channel that is not expired returns 200 (OK) rather than an error.

Request

POST https://relay-api.d6.co.za/api/business/v1/channels/{id}/unexpire

URL Parameters

Parameter Description
id The identifier of the channel which was returned upon creation.

Returns

An object with id, expired and expired_at attributes with status code 200 (OK).

Delete a Channel

curl -X "DELETE" "https://relay-api.d6.co.za/api/business/v1/channels/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
  "deleted": true
}

Deletes a specific channel permanently.

Request

DELETE https://relay-api.d6.co.za/api/business/v1/channels/{id}

URL Parameters

Parameter Description
id The identifier of the channel which was returned upon creation.

Returns

An object with an id and deleted attributes with status code 200 (OK).

List Channels

curl "https://relay-api.d6.co.za/api/business/v1/channels?page=1&per_page=20&sort=-name,created_at" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
  "data": [
    {
      "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
      "name": "Channel Name 2",
      ...
      "created_at": "2017-09-29T09:53:21Z",
      "updated_at": "2017-09-29T09:53:21Z"
    },
    {
      "id": "12f6ff6e-dbee-4408-a736-6a8d43ccaf3d",
      "name": "Channel Name",
      ...
      "created_at": "2017-09-22T08:29:00Z",
      "updated_at": "2017-09-22T08:29:00Z"
    }
  ],
  "pagination": {
    "total": 4,
    "count": 2,
    "per_page": 20,
    "current_page": 1,
    "total_pages": 2,
    "links": {
      "next": "http:\/\/relay-api.d6.co.za\/api\/business\/v1\/channels?page=2"
    }
  }
}

Returns a paginated list of all channels sorted by the most recently updated_at by default.

Request

GET https://relay-api.d6.co.za/api/business/v1/channels

Note: For situations where the query parameters are too long, a POST endpoint is also available that accepts the parameters in a JSON object: POST https://relay-api.d6.co.za/api/business/v1/channels/list

Query Parameters

Parameter Description
page
Optional
The page number to return (1-based). Defaults to 1.
per_page
Optional
The amount of channels to return per page. Defaults to 15.
sort
Optional
Comma separated string of properties to sort the channels by (ascending). Defaults to -updated_at.

Sortable Properties: name, type, created_at, updated_at.

Hint: Adding a - before the property name will reverse the sort order to descending. E.g. Sort by name descending then by created_at ascending: ?sort=-name,created_at.
search
Optional
Case insensitive string to search and filter channels by name.
ids
Optional
Comma separated string of channel IDs to filter.
community_ids
Optional
Comma separated string of community IDs to filter.
filter_by_type
Optional
Comma separated string of channel type values to filter by. Available types: grade, register_class, subject, house, boarding, campus, division, department, sports_team, cultural_group, supporters, staff, committee, parent_group, learner_group, announcement, ad_hoc, unspecified.
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: community, tags, persons.

Returns

A data array of channel objects as well as a pagination object with properties to keep track of the pagination. Status code: 200 (OK).

Attach Persons to a Channel

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/channels/{id}/persons/attach" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "person_ids": ["22f6f48b-e219-4eec-b4ce-04cad170ffff", "12f6f48b-e219-4eec-b4ce-04cad170fff1"]
            "update_app_channel_subscriptions": true
            "notify_subscription_changes_via_app": true
        }'

Example Response:

{
    "success": true
}

Attaches specified persons to a channel.

Request

POST https://relay-api.d6.co.za/api/business/v1/channels/{id}/persons/attach

Arguments (JSON)

Parameter Type Description
person_ids
Required
array Array of Person IDs to attach to this channel.
update_app_channel_subscriptions
Optional
boolean Whether any app users should automatically be subscribed to this channel. Defaults to true.
notify_subscription_changes_via_app
Optional
boolean If update_app_channel_subscriptions is true, whether the user should be notified via push notification and in feed message. Defaults to false.

Returns

A success object with status code 200 (OK).

Detach Persons from a Channel

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/channels/{id}/persons/detach" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "person_ids": ["22f6f48b-e219-4eec-b4ce-04cad170ffff", "12f6f48b-e219-4eec-b4ce-04cad170fff1"]
            "notify_subscription_changes_via_app": true
        }'

Example Response:

{
    "success": true
}

Detaches specified persons from a channel.

Request

POST https://relay-api.d6.co.za/api/business/v1/channels/{id}/persons/detach

Arguments (JSON)

Parameter Type Description
person_ids
Required
array Array of Person IDs to detach from this channel.
update_app_channel_subscriptions
Optional
boolean Whether any app users should automatically be unsubscribed from this channel. Defaults to true.
notify_subscription_changes_via_app
Optional
boolean If update_app_channel_subscriptions is true, whether the user should be notified via push notification and in feed message. Defaults to false.

Returns

A success object with status code 200 (OK).

Notices

Notices (or messages) refer to any published communication within a community. Notices can be delivered over different platforms such as email, sms and via the app.

Notices are composed of different components which each serve different purposes. E.g Creating a notice with a text and you_tube_video component will appear as text and a video within the app.

Notices are created with a draft status by default and need to be published using a dedicated /publish endpoint.

Components

Example Components:

{
    "type": "text",
    "media_type": "plain", // Required. Can be plain, markdown, or html
    "text": "Plain text goes here",
}

{
    "type": "file",
    "file_id": "file_id_goes_here", // The file ID returned from Dedicated File Upload Endpoint
}

{
    "type": "image",
    "image_id": "image_id", // The file ID returned from Dedicated File Upload Endpoint
}

{
    "type": "web_frame",
    "url": "https://d6.co.za",
}

{
    "type": "contact",
    "first_name" : "Merike",
    "last_name" : "van Zyl",
    "title_or_role" : "Secretary",
    "description" : "This is a short description.",
    "website" : "https://www.example.org",
    "primary_phone_number" : "+2766121312",
    "secondary_phone_number" : "012 361 3402",
    "primary_email" : "merike@example.org",
    "secondary_email" : "merike.secondary@example.org",
    "birthday": "24-07-1990",
    "twitter_handle" : "@merikeexample",
    "facebook_url" : "https://www.facebook.com/marikeexample",
}

{
    "type"              : "event",
    "title"             : "Rugby U/12 Practice",
    "description"       : "This is a short description.",
    "address"           : "159 Gousblom Avenue, Lynnwood, Pretoria",
    "start_date"        : "2020-03-21T10:30:00+0200", // ISO 8601 with local timezone
    "end_date"          : "2020-03-21T12:30:00+0200", // ISO 8601 with local timezone
    "all_day"           : false,  // note that this will modify start + end_dates to the start and end of those days
    "add_calendar"      : false, // whether to add to calendars related to the notice channels + persons
    "remind_minutes"    : 0, // number of minutes before the event start_date time to send a reminder (note how all_day will adjust the start_date when setting this). Defaults to 0 (no reminder).
    "repeat"            : "NEVER", // event repeat options: NEVER, DAILY, WEEKLY, MONTHLY, ANNUALLY, WEEK_DAY, CUSTOM
    "recurrence_rules"  : ["RRULE:FREQ=DAILY", "EXDATE:20221011T142200Z"], // array of custom recurrence rule strings, use repeat = CUSTOM along with this
}


{
    "type": "response_text",
    "title": "What is your name?",
    "required": true
}

{
    "type": "response_boolean",
    "title": "Are you enjoying the weather today?",
    "required": true
}

{
    "type": "response_choice",
    "title": "Choose your favourite fruit:",
    "required": true,
    "single_selection": true,
    "options": [
        "Apple",
        "Orange",
        "Strawberry"
    ],
    "min": 1,   // Optional, one can now use min and max (deprecates `single_selection`) to control the minimum and maximum number of selections the user can make.
    "max": 1    // Optional, max cannot be greater than the number of choices.
}

{
    "type": "response_file",
    "title": "Please provide the signed PDF document:",
    "required": true
}

{
    "type": "response_image",
    "title": "Please provide a photo of your dog:",
    "required": true
}

{
    "type": "location",
    "latitude": "-25.5868815",
    "longitude": "28.322987",
    "address": "Plot 52, Buffelsdrift Conservancy, Buffelsdrift St, Pretoria, 0130"
}


{
    "type": "youtube_video",
    "url": "https://www.youtube.com/watch?v=dQw4w9WgXcQ" // Needs to be a publically available YouTube url
}

{
    "type": "payment",
    "payment_type": "fixed", // fixed, open, itemised or partial
    "title": "School Spring Walk Entry Fee",
    "amount_smallest_unit": 10000, // Amount in the currency's smallest unit (e.g. cents). Min 100, max 50000000. Required unless payment_type is open
    "currency_iso_4217": "ZAR",
    "item_quantity_limit": null, // If itemised, optional integer to set overall stock limit
}

{
    "type": "album",
    "name": "Album with 5 Images", <--- NULLABLE
    "medias": [ <--- MAX OF 1000
        {
            "image_id": "965fe019-a366-444b-87fc-77e08bb59470" // File ID returned by our dedicated file upload endpoint.
        },
        {
            "image_id": "965fe01a-e4c6-46f0-b23b-aeda2299cb2f"
        },
        {
            "image_id": "965fe01a-e4d4-49bf-b06a-677fafad0ba9"
        },
        {
            "image_id": "965fe01b-7580-4a0e-a0a3-c4012de60b64"
        },
        {
            "image_id": "965fe01b-72fc-4306-b1ac-742d3c3a2330"
        }
    ]
}

{
    "type": "url",
    "url": "https://www.d6.co.za", // Needs to be a publically available url
    "title": "d6.co.za",            // Nullable
    "description": "d6 Home page",  // Nullable
    "thumbnail_url": null           
}


The following components are currently available via the API:

Type Description
text Supported media types: plain, markdown or html. If HTML, supports the following tags: <p>, <em>, <ins>, <del>, <strong>, <sup>, <sub>, <h1>, <h2>, <h3>, <h4>, <h5>, <h6>, <blockquote>, <pre>, <ol>, <ul>, <li>, <a>
file Used for sharing specific files. Max 50MB. Most formats are supported.
image Individual image to display. Max 50MB. Supported formats: jpeg, png, gif, heic, heif
web_frame Akin to an iFrame, display an entire website within the notice. Temporarily disabled: requests containing a web_frame component are rejected with a validation error; use a text or url component with the URL instead.
contact Display a contact within the notice that users can share/save.
event Display an event within the notice that users can share/save.
response_text Allows users to respond to the notice with any text.
response_boolean Allows users to respond to boolean questions.
response_choice Allows users to respond with either single or multiple choices.
response_file Allows users to respond with a file.
response_image Allows users to respond with an image.
location Display a location within a notice. Users can view a map and can navigate to the location.
youtube_video Display a video within the notice. Users can play the video.
payment Displays a payment item. Users can pay with supported payment methods configured for the community of the notice.
album Used for displaying multiple images. Max of 1000 images. Supported formats: jpeg, png, gif, heic, heif
url Display an interactable link within a notice or resource.

Create a Notice

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/notices" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H 'Content-Type: application/json; charset=utf-8' \
     -d $'{
            "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8"
            "channel_ids": [
                "32f6f48b-e219-4eec-b4ce-04cad170ffa9"
            ],
            "person_ids": [
                "aaf6f48b-e219-4eec-24ce-04cad17000a0",
            ],
            "title": "A Notice With Some Text and a Link",
            "components": [
                {
                    "type": "text",
                    "media_type": "html",
                    "text": "<p><strong>Hello everyone!</strong></p><p>This component supports basic HTML tags.</p>"
                },
                {
                    "type": "url",
                    "url": "https://d6.co.za"
                }
            ]
        }'

Example Response:

{
    "id": "22f6f48b-e219-4eec-b4ce-04cad170ffff",
    "community_id": "12f6f48b-e219-4eec-b4ce-04cad170ffa8",
    "status": "draft",
    "status_at": "2021-03-16T11:50:55Z",
    "title": "A Notice With Some Text and a Link",
    "author": "Example Community",
    "target_everyone": false,
    "important": false,
    "answerable": false,
    "payable": false,
    "votable": false,
    "publish_platform_app": false,
    "publish_platform_email": false,
    "publish_platform_sms": false,
    "publish_platform_whatsapp": false,
    "publish_sandbox_app": false,
    "publish_sandbox_email": false,
    "publish_sandbox_sms": false,
    "publish_sandbox_whatsapp": false,
    "created_at": "2021-03-16T11:50:55Z",
    "updated_at": "2021-03-16T11:50:55Z",
    "edited_at": null,
    "deadline_at": "2022-02-01T09:02:01Z",
    "has_hard_deadline": false
}

Creates a new notice.

Request

POST https://relay-api.d6.co.za/api/business/v1/notices

Arguments (JSON)

Parameter Type Description
community_id
Required
string The identifier of the community that this notice belongs to.
title
Required
string The title of the notice. Max length of 255 characters.
target_everyone
Optional
boolean Whether everyone in the community should be targeted. Omit channel_ids, person_ids when this is set to true.
channel_ids
Optional
array Array of channel IDs this notice should target.
person_ids
Optional
array Array of person IDs this notice should target.
components
Required
array Array of component objects to build the notice with (min 1, max 100). Components are discussed in detail above.
important
Optional
boolean Whether this is an important notice. This affects the way the notice is presented across the different platforms (E.g 'IMPORTANT' in email title and red looking notice cells/rows in the app).
deadline_at
Optional
string Date and time representing the last moment at which responses and votes will be still be accepted from a member. ISO 8601 with local timezone. Nullable.
publish_relationship
Optional
string Which linked persons should receive the notice. One of default, root_only, children_only, parents_only. Defaults to default.

Returns

The newly created notice object with status code 201 (Created).

Retrieve a Notice

curl "https://relay-api.d6.co.za/api/business/v1/notices/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Retrieves a specific notice.

Request

GET https://relay-api.d6.co.za/api/business/v1/notices/{id}

URL Parameters

Parameter Description
id The identifier of the notice which was returned upon creation.

Query Parameters

Parameter Description
expand
Optional
Comma separated string of relationships to include in the response.

Expandable Relationships: community, channels, components.

Returns

The notice object with status code 200 (OK).

Retrieve Publish Breakdown

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/notices/{id}/publish/breakdown" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
            "strategy": "cheapest",
            "platforms": [
                "app",
                "email",
                "sms"
            ]
        }'

Example Response:

{
    "total": 12,
    "num_app": 10,
    "num_email": 2,
    "num_sms": 0,
    "num_whatsapp": 0,
    "num_unreachable": 0
}

Get the reachable count for a notice grouped by platform: app, email & sms. This allows you to see how a notice will reach everyone once published.

Request

POST https://relay-api.d6.co.za/api/business/v1/notices/{id}/publish/breakdown

URL Parameters

Parameter Description
id The identifier of the notice which was returned upon creation.

Arguments (JSON)

Parameter Type Description
strategy
Required
string Either cheapest or send_all.

The cheapest strategy will try send notice to anyone with the app, if they don't have the app, then via email if they have an email address. Lastly, if they don't have an email on record, then via SMS if they have a phone number on record.

The send_all strategy will send the notice across all platforms even if it means the end user will receive it across multiple platforms.
platforms
Optional
array Array of platforms to target. Available platforms: app, email, sms.
relationship
Optional
string One of default, root_only, children_only, parents_only. Defaults to the publish_relationship set on the notice.

Returns

The breakdown object with status code 200 (OK).

Update a Notice

curl -X "PUT" "https://relay-api.d6.co.za/api/business/v1/notices/{id}" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
          "title": "Updated Title"
         }'

Example Response:

{
    "id": "96662f9c-974c-49c8-8315-f3de489f8ad7",
    "community_id": "95d372ec-5c85-46c3-a4de-3fe6058dbcaf",
    "status": "draft",
    "status_at": "2022-05-27T12:58:16Z",
    "title": "Updated Title",
    "author": "Example Community",
    "target_everyone": false,
    "important": false,
    "answerable": false,
    "payable": false,
    "votable": false,
    "publish_platform_app": false,
    "publish_platform_email": false,
    "publish_platform_sms": false,
    "publish_platform_whatsapp": false,
    "publish_sandbox_app": false,
    "publish_sandbox_email": false,
    "publish_sandbox_sms": false,
    "publish_sandbox_whatsapp": false,
    "created_at": "2022-05-27T12:58:16Z",
    "updated_at": "2022-05-27T12:59:00Z",
    "edited_at": null,
    "deadline_at": null,
    "has_hard_deadline": false
}

Updates a specific notice. Only specified arguments will be changed, omitted arguments will remain unchanged.

Request

PUT https://relay-api.d6.co.za/api/business/v1/notices/{id}

URL Parameters

Parameter Description
id The identifier of the notice which was returned upon creation.

Arguments (JSON)

Parameter Type Description
title
Optional
string The title of the notice. Max length of 255 characters.
components
Optional
array Array of edited components to build the notice with (min 1, max 100).
target_everyone
Optional
boolean Whether everyone in the community should be targeted. Omit channel_ids, person_ids when this is set to true.
channel_ids
Optional
array Array of channel IDs this notice should target.
person_ids
Optional
array Array of person IDs this notice should target.
important
Optional
boolean Whether this is an important notice.
deadline_at
Optional
string Date and time representing the last moment at which responses and votes will be still be accepted from a member. ISO 8601 with local timezone. Nullable.

Returns

The updated notice object with status code 200 (OK).

Publish Notice

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/notices/{id}/publish" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json" \
     -H "Content-Type: application/json" \
     -d '{
            "strategy": "cheapest",
            "platforms": ["app"],
            "send_push_notification": true
        }'

Example Response:

{
    "success": true
}

Publish a specific notice. Once notices are published, they cannot be published again (a 422 validation error is returned). Publishing happens asynchronously; the notice status will move to publishing and then published.

Request

POST https://relay-api.d6.co.za/api/business/v1/notices/{id}/publish

URL Parameters

Parameter Description
id The identifier of the notice which was returned upon creation.

Arguments (JSON)

Parameter Type Description
strategy
Required
string Either cheapest or send_all.

The cheapest strategy will try send notice to anyone with the app, if they don't have the app, then via email if they have an email address. Lastly, if they don't have an email on record, then via SMS if they have a phone number on record.

The send_all strategy will send the notice across all platforms even if it means the end user will receive it across multiple platforms.
platforms
Optional
array Array of platforms to target. Available platforms: app, email, sms.
send_push_notification
Optional
boolean Whether app users should receive a push notification for this notice. Defaults to false.
relationship
Optional
string One of default, root_only, children_only, parents_only. Defaults to the publish_relationship set on the notice.

Returns

Success object status code 200 (OK).

Archive a Notice

curl -X "POST" "https://relay-api.d6.co.za/api/business/v1/notices/{id}/archive" \
     -H "Authorization: Bearer {ACCESS_TOKEN}" \
     -H "Accept: application/json"

Example Response:

{
    "success": true
}

[...]
